package com.wadpam.open.dao;

import java.io.Serializable;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import net.sf.mardao.core.CursorPage;
import net.sf.mardao.core.dao.Dao;
import com.wadpam.open.domain.DApp;
import net.sf.mardao.core.geo.DLocation;

/**
 * DAO interface with finder methods for DApp entities.
 *
 * Generated on 2013-04-24T10:40:29.617+0700.
 * @author mardao DAO generator (net.sf.mardao.plugin.ProcessDomainMojo)
 */
public interface GeneratedDAppDao extends Dao<DApp, java.lang.String> {

	/** Column name for primary key attribute is "domainName" */
	static final String COLUMN_NAME_DOMAINNAME = "domainName";


	/** Column name for field apiPassword is "apiPassword" */
	static final String COLUMN_NAME_APIPASSWORD = "apiPassword";
	/** Column name for field apiUser is "apiUser" */
	static final String COLUMN_NAME_APIUSER = "apiUser";
	/** Column name for field appAdmins is "appAdmins" */
	static final String COLUMN_NAME_APPADMINS = "appAdmins";
	/** Column name for field createdBy is "createdBy" */
	static final String COLUMN_NAME_CREATEDBY = "createdBy";
	/** Column name for field createdDate is "createdDate" */
	static final String COLUMN_NAME_CREATEDDATE = "createdDate";
	/** Column name for field description is "description" */
	static final String COLUMN_NAME_DESCRIPTION = "description";
	/** Column name for field updatedBy is "updatedBy" */
	static final String COLUMN_NAME_UPDATEDBY = "updatedBy";
	/** Column name for field updatedDate is "updatedDate" */
	static final String COLUMN_NAME_UPDATEDDATE = "updatedDate";

	/** The list of attribute names */
	static final List<String> COLUMN_NAMES = Arrays.asList(		COLUMN_NAME_APIPASSWORD,
		COLUMN_NAME_APIUSER,
		COLUMN_NAME_APPADMINS,
		COLUMN_NAME_CREATEDBY,
		COLUMN_NAME_CREATEDDATE,
		COLUMN_NAME_DESCRIPTION,
		COLUMN_NAME_UPDATEDBY,
		COLUMN_NAME_UPDATEDDATE);
	/** The list of Basic attribute names */
	static final List<String> BASIC_NAMES = Arrays.asList(		COLUMN_NAME_APIPASSWORD,
		COLUMN_NAME_APIUSER,
		COLUMN_NAME_APPADMINS,
		COLUMN_NAME_CREATEDBY,
		COLUMN_NAME_CREATEDDATE,
		COLUMN_NAME_DESCRIPTION,
		COLUMN_NAME_UPDATEDBY,
		COLUMN_NAME_UPDATEDDATE);
	/** The list of attribute names */
	static final List<String> MANY_TO_ONE_NAMES = Arrays.asList();


	// ----------------------- field finders -------------------------------
	/**
	 * query-by method for field apiPassword
	 * @param apiPassword the specified attribute
	 * @return an Iterable of DApps for the specified apiPassword
	 */
	Iterable<DApp> queryByApiPassword(java.lang.String apiPassword);
		
	/**
	 * query-keys-by method for field apiPassword
	 * @param apiPassword the specified attribute
	 * @return an Iterable of DApps for the specified apiPassword
	 */
	Iterable<java.lang.String> queryKeysByApiPassword(java.lang.String apiPassword);

	/**
	 * query-page-by method for field apiPassword
	 * @param apiPassword the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DApps for the specified apiPassword
	 */
	CursorPage<DApp, java.lang.String> queryPageByApiPassword(java.lang.String apiPassword,
            int pageSize, String cursorString);


	/**
	 * query-by method for field apiUser
	 * @param apiUser the specified attribute
	 * @return an Iterable of DApps for the specified apiUser
	 */
	Iterable<DApp> queryByApiUser(java.lang.String apiUser);
		
	/**
	 * query-keys-by method for field apiUser
	 * @param apiUser the specified attribute
	 * @return an Iterable of DApps for the specified apiUser
	 */
	Iterable<java.lang.String> queryKeysByApiUser(java.lang.String apiUser);

	/**
	 * query-page-by method for field apiUser
	 * @param apiUser the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DApps for the specified apiUser
	 */
	CursorPage<DApp, java.lang.String> queryPageByApiUser(java.lang.String apiUser,
            int pageSize, String cursorString);


	/**
	 * query-by method for field appAdmins
	 * @param appAdmins the specified attribute
	 * @return an Iterable of DApps for the specified appAdmins
	 */
	Iterable<DApp> queryByAppAdmins(java.lang.Object appAdmins);
		
	/**
	 * query-keys-by method for field appAdmins
	 * @param appAdmins the specified attribute
	 * @return an Iterable of DApps for the specified appAdmins
	 */
	Iterable<java.lang.String> queryKeysByAppAdmins(java.lang.Object appAdmins);

	/**
	 * query-page-by method for field appAdmins
	 * @param appAdmins the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DApps for the specified appAdmins
	 */
	CursorPage<DApp, java.lang.String> queryPageByAppAdmins(java.lang.Object appAdmins,
            int pageSize, String cursorString);


	/**
	 * query-by method for field createdBy
	 * @param createdBy the specified attribute
	 * @return an Iterable of DApps for the specified createdBy
	 */
	Iterable<DApp> queryByCreatedBy(java.lang.String createdBy);
		
	/**
	 * query-keys-by method for field createdBy
	 * @param createdBy the specified attribute
	 * @return an Iterable of DApps for the specified createdBy
	 */
	Iterable<java.lang.String> queryKeysByCreatedBy(java.lang.String createdBy);

	/**
	 * query-page-by method for field createdBy
	 * @param createdBy the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DApps for the specified createdBy
	 */
	CursorPage<DApp, java.lang.String> queryPageByCreatedBy(java.lang.String createdBy,
            int pageSize, String cursorString);


	/**
	 * query-by method for field createdDate
	 * @param createdDate the specified attribute
	 * @return an Iterable of DApps for the specified createdDate
	 */
	Iterable<DApp> queryByCreatedDate(java.util.Date createdDate);
		
	/**
	 * query-keys-by method for field createdDate
	 * @param createdDate the specified attribute
	 * @return an Iterable of DApps for the specified createdDate
	 */
	Iterable<java.lang.String> queryKeysByCreatedDate(java.util.Date createdDate);

	/**
	 * query-page-by method for field createdDate
	 * @param createdDate the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DApps for the specified createdDate
	 */
	CursorPage<DApp, java.lang.String> queryPageByCreatedDate(java.util.Date createdDate,
            int pageSize, String cursorString);


	/**
	 * query-by method for field description
	 * @param description the specified attribute
	 * @return an Iterable of DApps for the specified description
	 */
	Iterable<DApp> queryByDescription(java.lang.String description);
		
	/**
	 * query-keys-by method for field description
	 * @param description the specified attribute
	 * @return an Iterable of DApps for the specified description
	 */
	Iterable<java.lang.String> queryKeysByDescription(java.lang.String description);

	/**
	 * query-page-by method for field description
	 * @param description the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DApps for the specified description
	 */
	CursorPage<DApp, java.lang.String> queryPageByDescription(java.lang.String description,
            int pageSize, String cursorString);


	/**
	 * query-by method for field updatedBy
	 * @param updatedBy the specified attribute
	 * @return an Iterable of DApps for the specified updatedBy
	 */
	Iterable<DApp> queryByUpdatedBy(java.lang.String updatedBy);
		
	/**
	 * query-keys-by method for field updatedBy
	 * @param updatedBy the specified attribute
	 * @return an Iterable of DApps for the specified updatedBy
	 */
	Iterable<java.lang.String> queryKeysByUpdatedBy(java.lang.String updatedBy);

	/**
	 * query-page-by method for field updatedBy
	 * @param updatedBy the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DApps for the specified updatedBy
	 */
	CursorPage<DApp, java.lang.String> queryPageByUpdatedBy(java.lang.String updatedBy,
            int pageSize, String cursorString);


	/**
	 * query-by method for field updatedDate
	 * @param updatedDate the specified attribute
	 * @return an Iterable of DApps for the specified updatedDate
	 */
	Iterable<DApp> queryByUpdatedDate(java.util.Date updatedDate);
		
	/**
	 * query-keys-by method for field updatedDate
	 * @param updatedDate the specified attribute
	 * @return an Iterable of DApps for the specified updatedDate
	 */
	Iterable<java.lang.String> queryKeysByUpdatedDate(java.util.Date updatedDate);

	/**
	 * query-page-by method for field updatedDate
	 * @param updatedDate the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DApps for the specified updatedDate
	 */
	CursorPage<DApp, java.lang.String> queryPageByUpdatedDate(java.util.Date updatedDate,
            int pageSize, String cursorString);


		  
	// ----------------------- one-to-one finders -------------------------

	// ----------------------- many-to-one finders -------------------------
	
	// ----------------------- many-to-many finders -------------------------

	// ----------------------- uniqueFields finders -------------------------
	
	
	// ----------------------- populate / persist method -------------------------

	/**
	 * Persist an entity given all attributes
	 */
	DApp persist(		java.lang.String domainName, 
		java.lang.String apiPassword, 
		java.lang.String apiUser, 
		java.util.Collection appAdmins, 
		java.lang.String description);	

}
